/*****************************************************************************/
/*   This program is developed by Borland C++ 3.1			      */
/******************************************************************************/
/*  Demo 16: One PCI-1202 Card demo.					      */
/*   To estimate the performance for P1202_Do(), P1202_Di() and P1202_Da().   */
/******************************************************************************/
#define  MYLIB
#include <time.h>
#include "P1202.H"

clock_t StartTick,EndTick;
int main()
{
   int	   i,j;
   WORD    wBoards,wRetVal;
   WORD    wDIOdata,wOutput;
   float   fSeconds,fMHz;
   DWORD   dwI;
   WORD    wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

   clrscr();

   /* initiaing P1202 card and detect how many P1202 card in PC */
   wRetVal=P1202_DriverInit(&wBoards);
   printf("Threr are %d P1202 Cards in this PC\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P1202 card in this PC !!!\n");
      exit(0);
   }

   /* dump every P1202 card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P1202_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
				     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }

   P1202_ActiveBoard( 0 );
   StartTick=clock();
   i=0;
   printf("Estimating the performance of P1202_Do(), please waiting...\n");
   for(dwI=0; dwI<1000000L; dwI++)
   {
      P1202_Do(wOutput);     /* Digital output */
   }
   EndTick=clock();
   fSeconds=(EndTick-StartTick)/CLK_TCK;
   fMHz=1.0/fSeconds;
   printf("StartTick:%ld   EndTick=%d\n",StartTick,EndTick);
   printf("It takes %5.3f second to run 1,000,000 times P1202_Do() !!!\n",fSeconds);
   printf("The performance of P1202_Do() is %5.2f MHz.\n",fMHz);
   printf("\n");

   StartTick=clock();
   printf("Estimating the performance of P1202_Di(), please waiting...\n");
   for(dwI=0; dwI<1000000L; dwI++)
   {
      P1202_Di(&wDIOdata);     /* Digital output */
   }
   EndTick=clock();
   fSeconds=(EndTick-StartTick)/CLK_TCK;
   fMHz=1.0/fSeconds;
   printf("StartTick:%ld   EndTick=%d\n",StartTick,EndTick);
   printf("It takes %5.3f second to run 1,000,000 times P1202_Di() !!!\n",fSeconds);
   printf("The performance of P1202_Di() is %5.2f MHz.\n",fMHz);
   printf("\n");

   StartTick=clock();
   printf("Estimating the performance of P1202_Da(), please waiting...\n");
   for(dwI=0; dwI<1000000L; dwI++)
   {
      P1202_Da(0,0x900);   /* DA CH:0 output 0x900 */
   }
   EndTick=clock();
   fSeconds=(EndTick-StartTick)/CLK_TCK;
   fMHz=1.0/fSeconds;
   printf("StartTick:%ld   EndTick=%d\n",StartTick,EndTick);
   printf("It takes %5.3f second to run 1,000,000 times P1202_Da() !!!\n",fSeconds);
   printf("The performance of P1202_Da() is %5.2f MHz.\n",fMHz);
   printf("\n");

   P1202_DriverClose();
   return 0;
}
