/**********************************************************************/
/*   This program is developed by MicroSoft C 5.1		       */
/***********************************************************************/
/*  Demo 17: One PCI-1202 Card MagicScan Function demo. 	       */
/*	 To acquire A/D CH:4, CH:3 and CH:5, then display the	       */
/*	 values for those three channels.			       */
/***********************************************************************/
#define  MYLIB
#include "P1202.H"

#define  DATACOUNT  250  // how many data is scan for a A/D channel

WORD   wDaNum=90,wAdClk=24;
WORD   wV0[DATACOUNT];	// AD ch:0 buffer
WORD   wV1[DATACOUNT];	// AD ch:1 buffer
WORD   wV2[DATACOUNT];	// AD ch:2 buffer

WORD   wPlot0[500]; //	transformed into wave form
int main()
{
   WORD    i,j;
   WORD    wBoards,wRetVal;
   WORD    wDIOdata;
   float   fVal;
   char    cShow[80];
   WORD    wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

   clrscr();  // a clear screen function in P1202MC?.LIB
   gotoxy(1,1);

   // initiaing P1202 card and detect how many P1202 card in PC
   wRetVal=P1202_DriverInit(&wBoards);
   printf("Threr are %d P1202 Cards in this PC\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P1202 card in this PC !!!\n");
      exit(0);
   }

   /* dump every P1202 card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P1202_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
				     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }

   // The P1202_ActiveBoard() function must be used to active a board,
   // then all operation will take effect to the actived board.

   printf("--------------------------------------------------\n");
   printf("Now Active First P1202 Card...\n");
   P1202_ActiveBoard( 0 );

   P1202_Do(0x1234);	 // Digital output
   P1202_Di(&wDIOdata);  // Digital input
   printf("Digital Output -> 1234H  |  Digital Input -> %04xH\n",wDIOdata);
   printf("\nHit any key to show data...\n");
   getch();

   for (i=0; i<DATACOUNT; i++)	 wV0[i]=wV1[i]=wV2[i]=0;
   wRetVal=P1202_ClearScan();
   wRetVal += P1202_AddToScan(4,0,1,0,0,0);
   wRetVal += P1202_SaveScan(0,wV0);
   wRetVal += P1202_AddToScan(3,0,1,0,0,0);
   wRetVal += P1202_SaveScan(1,wV1);
   wRetVal += P1202_AddToScan(5,0,1,0,0,0);
   wRetVal += P1202_SaveScan(2,wV2);
   wRetVal=P1202_StartScan(800,DATACOUNT);
   if(wRetVal==0)
   {
      printf("1st Card: P1202_StartScan OK.\n");
   }
   else
   {
      putch(0x07);
      printf("1st Card: P1202_StartScan Error !!!, return=%x\n\n",wRetVal);
      exit(0);
   }

   printf("Channel 4's data:\n");
   for(i=0; i<12; i++)
   {
       printf("[%03d]=%04xH  ",i,wV0[i]);
       if( i%4==3 )  printf("\n");
   }
   printf("\n");

   printf("Channel 3's data:\n");
   for(i=0; i<12; i++)
   {
       printf("[%03d]=%04xH  ",i,wV1[i]);
       if( i%4==3 )  printf("\n");
   }
   printf("\n");

   printf("Channel 5's wave form:\n");
   for(i=0; i<12; i++)
   {
       printf("[%03d]=%04xH  ",i,wV2[i]);
       if( i%4==3 )  printf("\n");
   }

   P1202_DriverClose();
   return 0;
}
