/*****************************************************************************/
/*   This program is developed by Microsoft C 5.1			      */
/******************************************************************************/
/* *First Card:  reading all A/D channels.				      */
/*     *For PCI-1202L user, the setting time is 3us.			      */
/*     *For PCI-1202H user, the setting time varying according to	      */
/*	  configuration code, please refer Page 28 of NAPPCI/win user mamual. */
/*     *for example: a PCI-1202H user who want to acquire A/D channel	      */
/*	       5 with configuration code 0x11, then the following statements  */
/*	       must be used.						      */
/*		->  P1202_SetChannelConfig(5,0x11);   // +/- 5V range	      */
/*		->  P1202_DelayUs(28);	     // delay 28 us settling time     */
/*		->  P1202_AdPolling(&AdVal); // get the AD value into AdVal   */
/******************************************************************************/
/*  Demo 3: One P1202 Card demo.					      */
/*	    To repeat sacn the A/D from CH:0 to CH 15, then display	      */
/*	    the scanned A/D value.					      */
/******************************************************************************/
#define  MYLIB
#include "P1202.H"

int main()
{
   WORD    i,j;
   WORD    wBoards;
   WORD    wRetVal,wCount,wADData;
   WORD    wDIOdata;
   DWORD   dwExact,dwOKs,dwErrors,dwScanCount,dwP1,dwP2,dwStatus;
   float   fVal,fAdVals[5];
   WORD    wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

   clrscr();  // a clear screen function in P1202MC?.LIB
   gotoxy(1,1);

   /* initiaing P1202 card and detect how many P1202 card in PC */
   wRetVal=P1202_DriverInit(&wBoards);
   printf("Threr are %d P1202 Cards in this PC\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P1202 card in this PC !!!\n");
      exit(0);
   }

   /* dump every P1202 card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P1202_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
				     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }


   /* The P1202_ActiveBoard() function must be used to active a board, */
   /* then all operation will take effect to the actived board.        */
   P1202_ActiveBoard( 0 );

   P1202_Do(0x55aa);	 /* Digital output */
   P1202_Di(&wDIOdata);  /* Digital input  */
   printf("Digital Output -> 55aaH  |  Digital Input -> %04xH\n",wDIOdata);
   printf("Hit any key to continue...\n");
   putch(0x07);
   getch();

   clrscr();
   wCount=0;
   gotoxy(1,1);  printf("First P1202 Card:");
   for( ;  ; )
   {
      gotoxy(20,1); printf("Count=%d",wCount++);
      for(i=0; i<16; i++)
      {
      // wRetVal=P1202_SetChannelConfig(i,0x00); // +/- 5V range for PCI-1202L
	 wRetVal=P1202_SetChannelConfig(i,0x10); // +/- 5V range for PCI-1202H
	 if( wRetVal>0 )
	 {
	    printf("*** (+/- 5.0V Range) SetChannelConfig Error ***");
	    printf("AD channel %02d -> SetCh Error %d !!!",i,wRetVal);
	    putch(0x07);  getch();
	    return 0;
	 }

      // wRetVal+=P1202_DelayUs(3);  //  3 us settling time for PCI-1202L
	 wRetVal+=P1202_DelayUs(23); // 23 us settling time for PCI-1202H
	 if( wRetVal>0 )
	 {
	    printf("*** (+/- 5.0V Range) DelayUs Error ***");
	    printf("AD channel %02d -> Delay Error %d !!!",i,wRetVal);
	    putch(0x07);  getch();
	    return 0;
	 }

	 wRetVal=P1202_AdPolling(&fVal);
	 wADData=(WORD)(fVal/5.0*2048.0+2048);
	 if( wRetVal>0 )
	 {
	    printf("*** (+/- 5.0V Range) AdPolling Error ***");
	    printf("AD channel %02d -> Polling Error %d !!!",i,wRetVal);
	    putch(0x07);  getch();
	    return 0;
	 }
	 else
	 {
	    gotoxy(2,2+i);
	    printf(" (+/- 5.0V) ch:%02d -> %+5.3fV | %04xH  ",
							i,fVal,wADData);
	 }
	 /*-----------------------------------------------------------*/
      // wRetVal=P1202_SetChannelConfig(i+16,0x00); // +/- 5V range for PCI-1202L
	 wRetVal=P1202_SetChannelConfig(i+16,0x10); // +/- 5V range for PCI-1202H
	 if( wRetVal>0 )
	 {
	    printf("*** (+/- 5.0V Range) SetChannelConfig Error ***");
	    printf("AD channel %02d -> SetCh Error %d !!!",i+16,wRetVal);
	    putch(0x07);  getch();
	    return 0;
	 }

      // wRetVal+=P1202_DelayUs(3);  //  3 us settling time for PCI-1202L
	 wRetVal+=P1202_DelayUs(23); // 23 us settling time for PCI-1202H
	 if( wRetVal>0 )
	 {
	    printf("*** (+/- 5.0V Range) DelayUs Error ***");
	    printf("AD channel %02d -> Delay Error %d !!!",i+16,wRetVal);
	    putch(0x07);  getch();
	    return 0;
	 }

	 wRetVal=P1202_AdPolling(&fVal);
	 wADData=(WORD)(fVal/5.0*2048.0+2048);
	 if( wRetVal>0 )
	 {
	    printf("*** (+/- 5.0V Range) AdPolling Error ***");
	    printf("AD channel %02d -> Polling Error %d !!!",i+16,wRetVal);
	    putch(0x07);  getch();
	    return 0;
	 }
	 else
	 {
	    gotoxy(40,2+i);
	    printf(" (+/- 5.0V) ch:%02d -> %+5.3fV | %04xH",
							i+16,fVal,wADData);
	 }

      }

      if( kbhit() )
	 break;
      for(j=0; j<100; j++)
	 P1202_DelayUs(1000);  // delay 100 ms just for display purpose
   }


   P1202_DriverClose();
   return 0;
}

