/**********************************************************************/
/*   This program is developed by Turbo C 2.0			       */
/***********************************************************************/
/*  Demo 17: One PCI-1202 Card MagicScan Function demo. 	       */
/*	 To acquire A/D CH:4, CH:3 and CH:5, then display the	       */
/*	 values for those three channels.			       */
/***********************************************************************/
#define  MYLIB
#include "P1202.H"

#define  DATACOUNT  250

WORD   wDaNum=90,wAdClk=24;
WORD   wV0[DATACOUNT];	/* AD ch:4 buffer */
WORD   wV1[DATACOUNT];	/* AD ch:3 buffer */
WORD   wV2[DATACOUNT];	/* AD ch:5 buffer */

WORD   wPlot0[500];  /* transformed into wave form */
int main()
{
   WORD    i,j;
   WORD    wBoards,wRetVal;
   WORD    wDIOdata;
   float   fVal;
   char    cShow[80];
   WORD    wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

   clrscr();

   /* initiaing P1202 card and detect how many P1202 card in PC */
   wRetVal=P1202_DriverInit(&wBoards);
   printf("Threr are %d P1202 Cards in this PC\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P1202 card in this PC !!!\n");
      exit(0);
   }

   /* dump every P1202 card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P1202_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
				     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }

   /* The P1202_ActiveBoard() function must be used to active a board, */
   /* then all operation will take effect to the actived board.        */

   printf("--------------------------------------------------\n");
   printf("Now Active First P1202 Card...\n");
   P1202_ActiveBoard( 0 );

   P1202_Do(0x1234);	 /* Digital output */
   P1202_Di(&wDIOdata);  /* Digital input  */
   printf("Digital Output -> 1234H  |  Digital Input -> %04xH\n",wDIOdata);
   printf("\nHit any key to show wave form.\n");
   getch();


   for (i=0; i<DATACOUNT; i++)	 wV0[i]=wV1[i]=wV2[i]=0;
   wRetVal=P1202_ClearScan();
   wRetVal += P1202_AddToScan(4,0,1,0,0,0);  /* channel 4 to scan */
   wRetVal += P1202_SaveScan(0,wV0);
   wRetVal += P1202_AddToScan(3,0,1,0,0,0);  /* channel 3 to scan */
   wRetVal += P1202_SaveScan(1,wV1);
   wRetVal += P1202_AddToScan(5,0,1,0,0,0);  /* channel 5 to scan */
   wRetVal += P1202_SaveScan(2,wV2);
   wRetVal=P1202_StartScan(200,DATACOUNT);   /* sampling rate 8M/200 */

   graphic_init();
   cleardevice();
   setcolor(RED);
   if(wRetVal==0)
   {
      sprintf(cShow,"1st Card: P1202_StartScan OK.");
      outtextxy(10,10,cShow);
   }
   else
   {
      cleardevice();
      closegraph();
      putch(0x07);
      printf("1st Card: P1202_StartScan Error !!!, return=%x\n\n",wRetVal);
      exit(0);
   }

   sprintf(cShow,"Channel 4's wave form:");
   outtextxy(10,30,cShow);
   for(i=0; i<DATACOUNT; i++)  /* channel 4's data and its wave form */
      wPlot0[i]=30-(wV0[i]/36);
   for(i=0; i<DATACOUNT-1; i++)  /* plot channel 4's wave form */
      line(10+i,wPlot0[i],10+i+1,wPlot0[i+1]);

   sprintf(cShow,"Channel 3's wave form:");
   outtextxy(10,130,cShow);
   for(i=0; i<DATACOUNT; i++)	 /* channel 3's data and its wave form */
      wPlot0[i]=130-(wV1[i]/36);
   for(i=0; i<DATACOUNT-1; i++)  /* plot channel 3's wave form */
      line(10+i,wPlot0[i],10+i+1,wPlot0[i+1]);

   sprintf(cShow,"Channel 5's wave form:");
   outtextxy(10,230,cShow);
   for(i=0; i<DATACOUNT; i++)	 /* channel 5's data and its wave form */
      wPlot0[i]=230-(wV2[i]/36);
   for(i=0; i<DATACOUNT-1; i++)  /* plot channel 5's wave form */
      line(10+i,wPlot0[i],10+i+1,wPlot0[i+1]);

   getch();
   cleardevice();
   closegraph();

   P1202_DriverClose();
   return 0;
}

graphic_init()
{
   int driver,mode,char_size;

   driver=EGA;
   mode=EGAHI;
   initgraph(&driver,&mode,"");
   setactivepage(0);
   setvisualpage(0);
   setcolor(0);
   setbkcolor(15);
   settextstyle(SMALL_FONT,HORIZ_DIR,6);
   return 0;
}

