/**********************************************************************/
/*   This program is developed by Turbo C 2.0			       */
/***********************************************************************/
/*  Demo 7: one PCI-1202 card M_FUN_2 demo.			       */
/***********************************************************************/
#define  MYLIB
#include "P1202.H"

int	iLine;
float	fAdBuf[510];
WORD	wAdClk;

WORD	 wDa[320],wAd[510];
WORD	 wPlot0[512]; /*  transformed into wave form  */

int main()
{
   int	   i,j;
   WORD    wBoards,wRetVal;
   WORD    wDIOdata;
   DWORD   dwExact,dwOKs,dwErrors,dwScanCount,dwP1,dwP2,dwStatus;
   double  dfAdFrequency;
   float   fSampleRate;
   WORD   wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

   /* initiaing P1202 card and detect how many P1202 card in PC */
   wRetVal=P1202_DriverInit(&wBoards);
   printf("Threr are %d P1202 Cards in this PC\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P1202 card in this PC !!!\n");
      exit(0);
   }

   /* dump every P1202 card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P1202_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
				     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }

   /* The P1202_ActiveBoard() function must be used to active a board, */
   /* then all operation will take effect to the actived board.        */
   P1202_ActiveBoard( 0 );

   P1202_Do(0x1234);	 /* Digital output */
   P1202_Di(&wDIOdata);  /* Digital input  */
   printf("Digital Output -> 1234H  |  Digital Input -> %04xH\n",wDIOdata);
   printf("\nHit any key to continue...\n");
   getch();
   /************** M2 Function	****************************/

   graphic_init();
   cleardevice();

   for(i=0; i<64; i++) wDa[i]=0x800-i*16;
   for(i=0; i<64; i++) wDa[i+64]=0x800-(64-i)*16;
   for(i=0; i<64; i++) wDa[i+64*2]=0x800;
   for(i=0; i<64; i++) wDa[i+64*3]=0x800-64*8;
   for(i=0; i<64; i++) wDa[i+64*4]=0x800;

   for (i=0; i<510; i++)
   {
      wAd[i]=0;
   }

   wRetVal=P1202_M_FUN_2(320,40,wDa,80,510,0,wAd);
   if (wRetVal==0)
	printf("P1202_M_FUN_2 OK\n");
   else
	printf("P1202_M_FUN_2 ERROR, return=%x\n",wRetVal);

   setcolor(RED);
   for(i=0; i<501; i++)  /* channel 0's data and its wave form */
   {
      wPlot0[i]=100-(wAd[i]/16);
   }
   for(i=0; i<500; i++)  /* plot channel 0's wave form */
   {
      line(10+i,wPlot0[i],10+i+1,wPlot0[i+1]);
   }

   getch();
   cleardevice();
   closegraph();

   P1202_DriverClose();
   return 0;
}

/* -------------------------------------------------------------------- */

graphic_init()
{
   int driver,mode,char_size;

   driver=EGA;
   mode=EGAHI;
   initgraph(&driver,&mode,"");
   setactivepage(0);
   setvisualpage(0);
   setcolor(0);
   setbkcolor(15);
   settextstyle(SMALL_FONT,HORIZ_DIR,6);
   return 0;
}

